//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TfmMain *fmMain;
//---------------------------------------------------------------------------
__fastcall TfmMain::TfmMain(TComponent* Owner)
	: TForm(Owner)
{
 fmCustom=new TfmCustom(this);
 if(!fmCustom)
 {
  MessageBox(0, " .", "", 0);
  exit(1);
 }
 field=NULL;
 col[0]=0xa0ffff;
 col[1]=0x9ff3ff;
 col[2]=0x9fe8ff;
 col[3]=0x9fdbff;
 col[4]=0x9fcfff;
 col[5]=0x9fb8ff;
 col[6]=0x9f9fff;
 col[7]=0x0000ff; /*  */
 col[8]=0xa0a0a0; /*   */

 BeginGame();
}
//---------------------------------------------------------------------------
void TfmMain::BeginGame(void)
/*    */
{
 randomize();
 s32=0.866025403; //   3- 
 rbp=lbp=0;
 xoffs=150.0; //   x
 yoffs=50.0; //   y
 theend=0; /*      */
 a=12; //  

 InitConfig(); //      

 minesleft=mines; /*        */
 emptyfields=3*n*n-3*n+1-mines;
 firstclick=1; /*   */

 /*    */
 fmMain->Width=(2*n-1)*2*(s32*(float)a)+pnMinesLeft->Width+btStart->Width+4;
 fmMain->Height=(3*n+1.5)*a+pnMinesLeft->Height+4+32;
 pnMinesLeft->Left=2;
 pnMinesLeft->Top=2;
 btStart->Left=fmMain->Width-btStart->Width-8;
 btStart->Top=2;
 xoffs=pnMinesLeft->Width+2+n*s32*a;
 yoffs=pnMinesLeft->Height+2;

 pnMinesLeft->Caption=(int) minesleft; /*    */
 InitFieldArray();
 fmMain->Refresh(); /*    */
}
//---------------------------------------------------------------------------
char TfmMain::IsHidden(int i, int j)
/*   (i, j)? */
{
 if(field[GetOffs(i, j)]&8) return(1);
 return(0);
}
//---------------------------------------------------------------------------
char TfmMain::IsEmpty(int i, int j)
/*  (i, j) ? */
{
 if(!(field[GetOffs(i, j)]&7)) return(1);
 return(0);
}
//---------------------------------------------------------------------------
char TfmMain::IsMine(int i, int j)
/*    (i, j)? */
{
 if((field[GetOffs(i, j)]&7)==7) return(1);
 return(0);
}
//---------------------------------------------------------------------------
void TfmMain::ClickField(int i, int j)
/*     */
{
 if(IsHidden(i, j))
 {
  emptyfields--; /*   */
 }
 field[GetOffs(i, j)]&=7; /*    */
 if(!field[GetOffs(i, j)]) ShowEmptyArea(i, j); /*  ,   */
 if(field[GetOffs(i, j)]==7) /* !   */
 {
/*  int k;
  for(k=0; k<3*n*n-3*n+1; k++)
  if(field[k]==15) field[k]&=7; /*       */
  theend=1;
  fmMain->Refresh();
  MessageBox(0, "", "...", MB_TASKMODAL|MB_ICONSTOP);
 }
 DrawCell(i, j); /*    */
}
//---------------------------------------------------------------------------
void TfmMain::GetNeibs(char &ul, char &ur, char &r, char &br, char &bl, char &l, int i, int j)
/*   */
{
 ul=ur=r=l=br=bl=1; /*      */
 /*   */
 if(j==0) /*   */
  ur=ul=0; /*    */
 if(j==2*n-2) /*   */
  br=bl=0; /*    */
 if(i==0 && j<n-1) /*  ,   */
  ul=l=0;
 if(i==((j<=n-1)?(n+j-1):(3*n-j-3)) && j<n-1) /*  ,   */
  ur=r=0;
 if(i==0 && j>n-1) /*  ,   */
  bl=l=0;
 if(i==((j<=n-1)?(n+j-1):(3*n-j-3)) && j>n-1) /*  ,   */
  br=r=0;
 if(i==0 && j==n-1) /*   */
  bl=ul=l=0;
 if(i==((j<=n-1)?(n+j-1):(3*n-j-3)) && j==n-1) /*   */
  br=ur=r=0;
}
//---------------------------------------------------------------------------
void TfmMain::ShowEmptyArea(int i, int j)
/*    ,  .   (i, j) */
{
 /* ,     */
 char ul, ur, r, br, bl, l;
 GetNeibs(ul, ur, r, br, bl, l, i, j);
  /*    */
 if(j<n-1)
 {
  if(ul) if(IsHidden(i-1, j-1)) LeftButtonClick(i-1, j-1);
  if(ur) if(IsHidden(i, j-1)) LeftButtonClick(i, j-1);
  if(l)  if(IsHidden(i-1, j)) LeftButtonClick(i-1, j);
  if(r)  if(IsHidden(i+1, j)) LeftButtonClick(i+1, j);
  if(bl) if(IsHidden(i, j+1)) LeftButtonClick(i, j+1);
  if(br) if(IsHidden(i+1, j+1)) LeftButtonClick(i+1, j+1);
 }
 if(j==n-1)
 {
  if(ul) if(IsHidden(i-1, j-1))LeftButtonClick(i-1, j-1);
  if(ur) if(IsHidden(i, j-1))LeftButtonClick(i, j-1);
  if(l)  if(IsHidden(i-1, j))LeftButtonClick(i-1, j);
  if(r)  if(IsHidden(i+1, j))LeftButtonClick(i+1, j);
  if(bl) if(IsHidden(i-1, j+1))LeftButtonClick(i-1, j+1);
  if(br) if(IsHidden(i, j+1))LeftButtonClick(i, j+1);
 }
 if(j>n-1)
 {
  if(ul) if(IsHidden(i, j-1))LeftButtonClick(i, j-1);
  if(ur) if(IsHidden(i+1, j-1))LeftButtonClick(i+1, j-1);
  if(l)  if(IsHidden(i-1, j))LeftButtonClick(i-1, j);
  if(r)  if(IsHidden(i+1, j))LeftButtonClick(i+1, j);
  if(bl) if(IsHidden(i-1, j+1))LeftButtonClick(i-1, j+1);
  if(br) if(IsHidden(i, j+1))LeftButtonClick(i, j+1);
 }
}
//---------------------------------------------------------------------------
void TfmMain::CountMineNum(void)
/*        */
{
 int i, j;
 /* ,     */
 char ul, ur, r, br, bl, l;

 /*     */
 for(j=0; j<2*n-1; j++)
 {
  for(i=0; i<((j<=n-1)?(n+j):(3*n-j-2)); i++)
  {
   if(IsMine(i, j)) continue; /*     */
   GetNeibs(ul, ur, r, br, bl, l, i, j);
   /* C  */
   if(j<n-1)
   {
    if(ul) field[GetOffs(i, j)]+=IsMine(i-1, j-1);
    if(ur) field[GetOffs(i, j)]+=IsMine(i, j-1);
    if(l)  field[GetOffs(i, j)]+=IsMine(i-1, j);
    if(r)  field[GetOffs(i, j)]+=IsMine(i+1, j);
    if(bl) field[GetOffs(i, j)]+=IsMine(i, j+1);
    if(br) field[GetOffs(i, j)]+=IsMine(i+1, j+1);
   }
   if(j==n-1)
   {
    if(ul) field[GetOffs(i, j)]+=IsMine(i-1, j-1);
    if(ur) field[GetOffs(i, j)]+=IsMine(i, j-1);
    if(l)  field[GetOffs(i, j)]+=IsMine(i-1, j);
    if(r)  field[GetOffs(i, j)]+=IsMine(i+1, j);
    if(bl) field[GetOffs(i, j)]+=IsMine(i-1, j+1);
    if(br) field[GetOffs(i, j)]+=IsMine(i, j+1);
   }
   if(j>n-1)
   {
    if(ul) field[GetOffs(i, j)]+=IsMine(i, j-1);
    if(ur) field[GetOffs(i, j)]+=IsMine(i+1, j-1);
    if(l)  field[GetOffs(i, j)]+=IsMine(i-1, j);
    if(r)  field[GetOffs(i, j)]+=IsMine(i+1, j);
    if(bl) field[GetOffs(i, j)]+=IsMine(i-1, j+1);
    if(br) field[GetOffs(i, j)]+=IsMine(i, j+1);
   }
  }
 }
}
//---------------------------------------------------------------------------
void TfmMain::MarkFields(void)
/*      */
{
 int i;
 for(i=0; i<3*n*n-3*n+1; i++) field[i]|=8;
}
//---------------------------------------------------------------------------
void TfmMain::InitFieldArray(void)
/*    */
{
 int i;
 int cur; /*      */
 int numall=3*n*n-3*n+1; /*    */
 int j;

 field=(char*)realloc(field, numall); //  
 /*    */
 memset(field, 0, numall);
 /*   */
 for(i=0; i<mines; i++) field[i]=7; /*    */
 for(i=0; i<numall; i++) /*   */
 {
  cur=random(numall);
  j=field[i];
  field[i]=field[cur];
  field[cur]=(char)j;
 }
// CountMineNum(); /*   */
}
//---------------------------------------------------------------------------
int TfmMain::GetOffs(int i, int j)
/*         */
{
 return((j<=n-1)?(i+j*(n-1)+(j*(j+1))/2):(i+j*(n-1)+(j*(j+1))/2)-((j-n)*(j-n+1)));
}
//---------------------------------------------------------------------------
float TfmMain::GetX(int i, int j)
/*      X- */
{
 return((j<=n-1)?(-s32*j+2*s32*i):-s32*(n-1)+s32*(j-n+1)+2*s32*i);
}
//---------------------------------------------------------------------------
float TfmMain::GetY(int i, int j)
/*      Y- */
{
 return(1.5*j);
}
//---------------------------------------------------------------------------
void TfmMain::DrawCell(int X, int Y)
/*       (x,y) */
{
 POINT points[6];
 float x, y;
 int i;
 int nummines=field[GetOffs(X, Y)]; /*   */

 x=GetX(X, Y);
 y=GetY(X, Y);


 points[0].x=x*a; //   
 points[0].y=y*a;
 points[1].x=(x-s32)*a;
 points[1].y=(y+0.5)*a;
 points[2].x=(x-s32)*a;
 points[2].y=(y+1.5)*a;
 points[3].x=x*a;
 points[3].y=(y+2)*a;
 points[4].x=(x+s32)*a;
 points[4].y=(y+1.5)*a;
 points[5].x=(x+s32)*a;
 points[5].y=(y+0.5)*a;

 for(i=0; i<6; i++) // 
 {
  points[i].x+=xoffs;
  points[i].y+=yoffs;
 }
 if(theend) /*       */
 {
  if(nummines&8) fmMain->Canvas->Brush->Color=TColor(col[8]);
  else fmMain->Canvas->Brush->Color=TColor(col[nummines]);
  if((nummines&7)==7) fmMain->Canvas->Brush->Color=TColor(col[7]); /*     */
 }
 else
 {
  /*   ,      */
  if(nummines&8 || firstclick || nummines&16) fmMain->Canvas->Brush->Color=TColor(col[8]);
  else fmMain->Canvas->Brush->Color=TColor(col[nummines]);
 }

 fmMain->Canvas->Pen->Width=2; //  
 fmMain->Canvas->Pen->Color=clGray;
 fmMain->Canvas->Polygon(points, 5);

 fmMain->Canvas->Pen->Color=clBlack; //  
 fmMain->Canvas->Pen->Width=1;
 fmMain->Canvas->Polyline(points, 5);

 /*   */
 if(!(nummines&8) && nummines && (!firstclick) || nummines&16)
 {
  AnsiString tout;/* Text to be printed */
  if(nummines<7)tout=(AnsiString)(int)nummines;
//  else tout="X";

  fmMain->Canvas->Font->Color=(TColor) 0x000000;
  if(nummines&16)
  {
   tout="X";
   fmMain->Canvas->Font->Color=(TColor) 0x0000ff;
  }
  if(theend) fmMain->Canvas->Font->Color=(TColor) 0x000000;

  int w2=fmMain->Canvas->TextWidth(tout)/2; /* Half of width */
  int h2=fmMain->Canvas->TextHeight(tout)/2; /* Half of height */

 /*     */
  fmMain->Canvas->TextOut(x*a-w2+xoffs, (y+1)*a-h2+yoffs, tout);
 }
}
//---------------------------------------------------------------------------
void TfmMain::PaintFields(void)
/*    */
{
 int i, j;
 for(i=0; i<2*n-1; i++)
 {
  for(j=0; j<((i<=n-1)?(n+i):(3*n-i-2)); j++)
  {
   DrawCell(j, i);
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::FormPaint(TObject *Sender)
{
 PaintFields(); //  
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::FormMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
 if(Button==mbLeft) /*   */
 {
  lbp=1; /* ,     */
 }
 if(Button==mbRight) /*   */
 {
  rbp=1; /* ,     */
 }
}
//---------------------------------------------------------------------------
void TfmMain::RightButtonClick(int i, int j)
/*   */
{

 field[GetOffs(i, j)]^=16;

 if(field[GetOffs(i, j)]&16) minesleft--; /* ""  */
 else minesleft++; /* ""  */
 pnMinesLeft->Caption=(int) minesleft; /*    */

 DrawCell(i, j);
}
//---------------------------------------------------------------------------
void TfmMain::LeftButtonClick(int i, int j)
/*   */
{
 if(firstclick) /*  ,    -  */
 {
  firstclick=0;
  if(IsMine(i, j))
  {
   int cur;
   for(cur=0; cur<3*n*n-3*n+1; cur++)
   {
    if((field[cur]&7)!=7) /*    */
    {
     field[GetOffs(i, j)]=0; /*   */
     field[cur]=15;    /*    */
     break; /*    */
    }
   }
  }
  CountMineNum(); /*   */
  MarkFields();
  fmMain->Refresh();
 }
 if(field[GetOffs(i, j)]&16) return; /*  */
 ClickField(i, j);
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::FormDestroy(TObject *Sender)
{
 free(field);
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::FormMouseUp(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
 int i, j;
 int fl=0; /*     */
 float x=X-xoffs, y=Y-yoffs;
 x/=a;
 y/=a;
 int y0, x0;
 float y1, x1;

 if(theend) return; /*  ,    */
 /*          */
 if(y>1.5*n) /*      */
 {
  y=3*n-1-y;
  fl=1;
 }
 y0=((float)y)/1.5;
 y1=(float)y-((float)y0)*1.5;
 if(y1>=0.5)
 {
  j=y0;
  i=floor((x+((float)y0+1)*s32)/(s32*2));
 }
 else
 {
  x0=x/s32+(y0+1);
  x1=(float)x+(y0-x0+1)*s32;
  if(x0%2) // x0 - 
  {
   i=(x0-1)/2;
   if(y1<x1/(2*s32)) j=y0-1;
   else              j=y0;
  }
  else // x0 - 
  {
   if(x1/(2*s32)+y1<0.5)
   {
    j=y0-1;
    i=x0/2-1;
   }
   else
   {
    j=y0;
    i=x0/2;
   }
  }
 }
 /*      */
 if(i<0 || i>=n+j)
 {
  return;
 }
 if(fl) j=2*n-2-j;
 if(j<0 || j>2*n-2)
 {
  return;
 }

 if(Button==mbLeft) /*   */
 {
  lbp=0; /* ,     */
  if(rbp) /*   */
  {
   /*      */
   if(!(field[GetOffs(i, j)]&8)) ShowEmptyArea(i, j);
  }
  else if(!(field[GetOffs(i, j)]&16)) LeftButtonClick(i, j);
 }
 if(Button==mbRight) /*   */
 {
  rbp=0;
  if(lbp) /*   */
  {
   /*      */
   if(!(field[GetOffs(i, j)]&8)) ShowEmptyArea(i, j);
  }
  else
  {
   /* ,    */
   if(!(field[GetOffs(i, j)]&8)) return;
   RightButtonClick(i, j);
  }
 }
 if(!emptyfields && !theend) /*  */
 {
  theend=1;
//  minesleft=0; /* ,    */
  fmMain->Refresh(); /*  ,   
                           */
  MessageBox(0, "!", ".", MB_TASKMODAL);                        
 }
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::btStartClick(TObject *Sender)
{
 BeginGame();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::mmiEasyClick(TObject *Sender)
{
 mmiEasy->Checked=1;
 mmiMedium->Checked=0;
 mmiHard->Checked=0;
 mmiCustom->Checked=0;
 BeginGame();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::mmiMediumClick(TObject *Sender)
{
 mmiEasy->Checked=0;
 mmiMedium->Checked=1;
 mmiHard->Checked=0;
 mmiCustom->Checked=0;
 BeginGame();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::mmiHardClick(TObject *Sender)
{
 mmiEasy->Checked=0;
 mmiMedium->Checked=0;
 mmiHard->Checked=1;
 mmiCustom->Checked=0;
 BeginGame();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::mmiCustomClick(TObject *Sender)
{
 mmiEasy->Checked=0;
 mmiMedium->Checked=0;
 mmiHard->Checked=0;
 mmiCustom->Checked=1;

 fmCustom->ShowModal(); /*    */
 BeginGame();
}
//---------------------------------------------------------------------------
void TfmMain::InitConfig(void)
/*        */
{
 int numall; /*    */
 if(mmiCustom->Checked)
 /*  ,    */
 {
  n=(fmCustom->edSize->Text).ToIntDef(0);
  mines=(fmCustom->edNumMines->Text).ToIntDef(0);
 }
 if(mmiEasy->Checked)
 {
  n=5; /* 61  */
  mines=10;
 }
 if(mmiMedium->Checked)
 {
  n=10; /* 271  */
  mines=43;
 }
 if(mmiHard->Checked)
 {
  n=13; /* 469  */
  mines=99;
 }
 numall=3*n*n-3*n+1;
 if(n<2) n=2; /*    */
 if(mines<1) mines=1;
 if(numall/mines<2) /*    */
 {
  mines=numall/2;
 }
 if(mines<1) mines=1;
 /*      */
 fmCustom->edSize->Text=AnsiString(n);
 fmCustom->edNumMines->Text=AnsiString(mines);
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::mmiExitClick(TObject *Sender)
{
 fmMain->Close();	
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::mmiAboutClick(TObject *Sender)
{
 MessageBox(0, "    . www.katpop.narod.ru", " ", MB_TASKMODAL|MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::N2Click(TObject *Sender)
{
 MessageBox(0, "     . www.katpop.narod.ru", "", MB_TASKMODAL|MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
